<template>
  <div>
    <b-card :title="`Sessions for ${login}`">
      <b-card-sub-title>Latest session pings</b-card-sub-title>
      <b-table :items="sessionStates[this.login]" :fields="sessionStatesFields">
        <template #cell(login)="row">
          <b-link
            :href="`https://cri.epita.fr/users/${row.item.login}`"
            target="_blank"
            >{{ row.item.login }}</b-link
          >
        </template>
      </b-table>
      <b-card-sub-title>Sessions history</b-card-sub-title>
      <b-table :items="sessions[this.login]" :fields="sessionsFields">
        <template #cell(login)="row">
          <b-link
            :href="`https://cri.epita.fr/users/${row.item.login}`"
            target="_blank"
            >{{ row.item.login }}</b-link
          >
        </template>
      </b-table>
    </b-card>
  </div>
</template>

<script>
import * as errors from '~/utils/errors.js'

export default {
  middleware: ["auth"],
  computed: {
    login() {
      return this.$route.params.login
    },
    sessionStates() {
      return this.$store.getters['sessions_state/sessionStatesByLogin']
    },
    sessions() {
      return this.$store.getters['sessions_state/sessionsByLogin']
    },
    sessionStatesFields() {
      return [
        { key: 'ip', label: 'IP', sortable: true },
        { key: 'login', sortable: true },
        { key: 'image', sortable: true },
        { key: 'timestamp', sortable: true },
        { key: 'locked', sortable: true },
      ]
    },
    sessionsFields() {
      return [
        { key: 'ip', label: 'IP', sortable: true },
        { key: 'login', sortable: true },
        { key: 'image', sortable: true },
        { key: 'interval.lower', label: 'Start', sortable: true },
        { key: 'interval.upper', label: 'End', sortable: true },
      ]
    },
  },
  mounted() {
    this.refresh(null)
  },
  methods: {
    async refresh(event) {
      const getSessionsStates = this.$store
        .dispatch('sessions_state/getSessionsStates', this.login)
        .catch(errors.handleError(this))
      const getSessions = this.$store
        .dispatch('sessions_state/getSessions', this.login)
        .catch(errors.handleError(this))

      await getSessionsStates
      await getSessions
    },
  },
}
</script>
